#
# spec file for package openswan (Version 2.4.4)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cracklib curl curl-devel cvs cyrus-sasl db diffutils e2fsprogs expat file filesystem fillup findutils flex fltk fontconfig fontconfig-devel gawk gcc gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gmp gmp-devel gpm grep groff gzip htmldoc info insserv klogd less libacl libattr libcom_err libgcc libidn libidn-devel libjpeg libjpeg-devel libnscd libpcap libpng libstdc++ libtool libxcrypt libzio lynx m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl openssl-devel pam pam-modules patch perl permissions popt procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim xli xorg-x11-devel xorg-x11-libs zlib zlib-devel

Name:           openswan
BuildRequires:  curl-devel gmp-devel htmldoc libjpeg-devel libpcap lynx xorg-x11-devel
Version:        2.4.4
Release:        18.2
%define irel  2.4.4
License:        GPL
Group:          Productivity/Networking/Security
Summary:        IPsec Implementation which Allows Building of VPNs
URL:            http://www.openswan.org/
Provides:       pluto klips ipsec VPN freeswan
Obsoletes:      freeswan
PreReq:         gmp %insserv_prereq %fillup_prereq perl
Requires:       ipsec-tools iproute2
Autoreqprov:    on
Source:         http://www.openswan.org/download/%{name}-%{irel}.tar.gz
Source1:        http://www.openswan.org/download/%{name}-%{irel}.tar.gz.asc
Source10:       openswan.README.SUSE
Source30:       openswan.ipsec_1_to_2.pl
Source31:       sysconfig.network.scripts.openswan
Source32:       sysconfig.network.scripts.openswan-functions
Source33:       openswan.ip-up
#
Patch0:         openswan_00_features.dif
Patch1:         openswan_01_paths.dif
Patch2:         openswan_02_paths-lib64.dif
Patch3:         openswan_03_paths-docs.dif
Patch4:         openswan_04_rpmoptflags.dif
Patch6:         openswan_06_fix-perms.dif
Patch7:         openswan_07_doc-install.dif
Patch8:         openswan_08_doc-man2html.dif
Patch9:         openswan_09_doc-fixes.dif
#
Patch11:        openswan_11_gcc4cvshead.dif
Patch12:        openswan_12_gcc4sign.dif
#
Patch22:        openswan_22_send-notifications.dif
Patch23:        openswan_23_msl2tp-payload-malformed-workaround.dif
Patch24:        openswan_24_noaggressive.dif
#
Patch31:        openswan_31_autoleft.dif
Patch32:        openswan_32_updown-nexthop.dif
Patch33:        openswan_33_updown-srcmask.dif
Patch34:        openswan_34_startalways.dif
Patch35:        openswan_35_quiet-insmod.dif
Patch37:        openswan_37_aes_insmod.dif
#
Patch40:        openswan_40_rcscript.dif
Patch41:        openswan_41_preconfig.dif
Patch42:        openswan_42_plutowait-yes.dif
#
Prefix:         /usr
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
OpenS/WAN is the successor of FreeS/WAN.

OpenS/WAN is an IPsec implementation which allows building Virtual
Private Networks (VPNs). A typical VPN setup consists of two trusted
networks connected over an insecure network, typically the Internet.
OpenS/WAN allows you to create an encrypted tunnel through the insecure
area. Unlike CIPE, it is interoperable with other operating systems or
even router IPsec implementations



Authors:
--------
    John Gilmore <gnu@toad.com>
    Henry Spencer <henry@spsystems.net>
    Richard Guy Briggs <rgb@conscoop.ottawa.on.ca>
    Hugh Redelmeier <hugh@mimosa.com>
    Sandy Harris <sandy.harris@sympatico.ca>
    Hugh Daniels <hugh@toad.com>

%debug_package
%prep
%setup -q -n %{name}-%{irel}
#
%patch0
%patch1
%patch2
%patch3
%patch4
%patch6
%patch7
%patch8
%patch9
#
%patch11
%patch12
#
%patch22
%patch23
%patch24
#
%patch31
%patch32
%patch33
%patch34
%patch35
%patch37
#
%patch40
%patch41
%patch42
#

%build
make programs prefix=%{prefix} LIBD=%{_lib} DESTDIR=$RPM_BUILD_ROOT RPM_OPT_FLAGS="$RPM_OPT_FLAGS -W"
test -e programs/pluto/pluto

%install
test -z "$RPM_BUILD_ROOT" -o "$RPM_BUILD_ROOT" = "/" || rm -rf $RPM_BUILD_ROOT
make install prefix=%{prefix} LIBD=%{_lib} DESTDIR=$RPM_BUILD_ROOT
ln -sf /etc/init.d/ipsec ${RPM_BUILD_ROOT}%{prefix}/sbin/rcipsec
touch $RPM_BUILD_ROOT/etc/ipsec.secrets
#
install -m 755 %{SOURCE30} ${RPM_BUILD_ROOT}%{prefix}/lib/ipsec/ipsec_1_to_2.pl
install -d -m 755 %{buildroot}/etc/sysconfig/network/{scripts,if-up.d,if-down.d}
install -m 755 %{SOURCE31} %{buildroot}/etc/sysconfig/network/scripts/freeswan
install -m 644 %{SOURCE32} %{buildroot}/etc/sysconfig/network/scripts/freeswan-functions
ln -s ../scripts/freeswan %{buildroot}/etc/sysconfig/network/if-up.d/freeswan
ln -s ../scripts/freeswan %{buildroot}/etc/sysconfig/network/if-down.d/freeswan
# ip-up script (#39048)
install -d -m 755 %{buildroot}/etc/ppp/ip-{up,down}.d
install -m 755 %{SOURCE33} %{buildroot}/etc/ppp/ip-up.d/freeswan
ln -s ../ip-up.d/freeswan %{buildroot}/etc/ppp/ip-down.d/freeswan
#cd ${RPM_BUILD_ROOT}/%{_docdir}/%{name}
#chmod -x *.html *.txt *.ps *.pdf man/*.html
install -m 644 %SOURCE10 %{buildroot}/%{_docdir}/%{name}/README.SUSE
install -m 644 programs/_confread/README.conf.V2 %{buildroot}/%{_docdir}/%{name}/
rm -f %{buildroot}/etc/rc?.d/[KS]*ipsec

%files
%defattr(-,root,root)
/usr/sbin/ipsec
/usr/sbin/rcipsec
/usr/lib/ipsec
%if "%{_lib}" != "lib"
/usr/%{_lib}/ipsec/
%endif
%doc %{_mandir}/man3/ipsec*
%doc %{_mandir}/man5/ipsec*
%doc %{_mandir}/man5/pf*
%doc %{_mandir}/man8/ipsec*
%config /etc/init.d/ipsec
%attr(600,root,root) %config(noreplace) /etc/ipsec.secrets
#%attr(600,root,root) %config /etc/ipsec.secrets.rpmbuild
%config(noreplace) /etc/ipsec.conf
%dir /etc/ipsec.d/
%dir /etc/ipsec.d/cacerts
%dir /etc/ipsec.d/certs
%dir /etc/ipsec.d/crls
/etc/ipsec.d/policies
/etc/ipsec.d/examples
/etc/sysconfig/network/scripts/*
/etc/sysconfig/network/if-up.d/freeswan
/etc/sysconfig/network/if-down.d/freeswan
/etc/ppp/ip-up.d/freeswan
/etc/ppp/ip-down.d/freeswan
%dir %attr(700,root,root) /etc/ipsec.d/private
#%dir %doc %{_docdir}/%{name}
#%doc %attr(644,root,root) %{_docdir}/%{name}/*
%doc %{_docdir}/%{name}/
#%doc BUGS CHANGES COPYING CREDITS README 
#%doc doc/*.html doc/README.doc doc/std/* doc/Makefile
#%doc doc/*.notes doc/examples doc/prob.report doc/iab-iesg.stmt RFCs.tar.bz2
#%doc doc/*.howto doc/*.known-issues doc/*.txt linux/README.freeswan

%clean
test -z "$RPM_BUILD_ROOT" -o "$RPM_BUILD_ROOT" = "/" || rm -rf $RPM_BUILD_ROOT

%post
%{fillup_and_insserv ipsec}
if test ! -s etc/ipsec.secrets; then
  echo "Generating new rsasigkey for ipsec.secrets ..."
  cat >etc/ipsec.secrets.tmp << EOF
# This file holds shared secrets or RSA private keys for inter-Pluto
# authentication.  See ipsec_pluto(8) manpage, and HTML documentation.
#
# RSA private key for this host, authenticating it to any other host
# which knows the public part.  Suitable public keys, for ipsec.conf, DNS,
# or configuration of other implementations, can be extracted conveniently
# with "ipsec showhostkey".
EOF
  echo ': RSA	{' >> etc/ipsec.secrets.tmp
%ifarch s390 s390x ppc ppc64 ia64
  # S/390(x), PPC(64), ia64 kernels do not generate enough entropy even during an
  # installation(!) to produce good random numbers for the RSA key generation.
  # Defer to sysadmin.
  echo ""
  echo "# S/390(x), PPC(64) and ia64 do not reliably offer enough entropy :-("
  #if usr/lib/ipsec/rsasigkey --random dev/urandom 2048 >> etc/ipsec.secrets.tmp; then
  if false; then
%else
  if usr/%{_lib}/ipsec/rsasigkey 2048 >> etc/ipsec.secrets.tmp; then
%endif
    echo '  }' >> etc/ipsec.secrets.tmp
    echo '# do not change the indenting of that "}"' >> etc/ipsec.secrets.tmp
    chmod 600 etc/ipsec.secrets.tmp
    mv -f etc/ipsec.secrets.tmp etc/ipsec.secrets
  else
    rm -f etc/ipsec.secrets.tmp
    echo -e "\e[31m IPsec RSA signature key could not be generated!\e[m\017"
    echo " Generate one manually with \"ipsec newhostkey --output /etc/ipsec.secrets\""
    echo " Generate an RSA key with \"ipsec newhostkey --output /etc/ipsec.secrets\"" >etc/ipsec.secrets
    echo " Make sure, your kernel has enough entropy by e.g. using the keyboard." >>etc/ipsec.secrets
  fi
else
  echo "Leave old IPsec RSA signature key untouched."
  # Remove empty ipsec.secrets.rpmnew
  if test -e etc/ipsec.secrets.rpmnew -a ! -s etc/ipsec.secrets.rpmnew; then
    rm etc/ipsec.secrets.rpmnew
  fi
fi
if ! grep -q "version[	 ]*2\.0" /etc/ipsec.conf; then
  echo "Migrate config to v2.0 ..."
  mv --backup=numbered /etc/ipsec.conf /etc/ipsec.conf.v1
  /usr/lib/ipsec/ipsec_1_to_2.pl </etc/ipsec.conf.v1 >/etc/ipsec.conf
  PEMS=/etc/ipsec.d/*.pem
  if test "$PEMS" != "/etc/ipsec.d/*.pem"; then
    cp -p --backup=numbered $PEMS /etc/ipsec/certs/
    echo -e "The certificates\n$PEMS\nhave been copied to /etc/ipsec/certs/" \
	>>/var/adm/notify/messages/freeswan 
    echo "You may want to remove the old copies as soon as you stopped" \
	>>/var/adm/notify/messages/freeswan 
    echo -e "using FreeS/WAN-1.9x\n" >>/var/adm/notify/messages/freeswan 
  fi
fi
#%preun
#usr/sbin/rcipsec stop

%preun
# Some people expect to not loose their secrets even after multiple rpm -e.
if test -s etc/ipsec.secrets.rpmsave; then
  cp -p --backup=numbered etc/ipsec.secrets.rpmsave etc/ipsec.secrets.rpmsave.old
fi
exit 0

%postun
%{insserv_cleanup}

%changelog -n openswan
* Thu Mar 16 2006 - mt@suse.de
- Bug #148385, fixed further documentation inconsistence
  pointed out by Martin Mrazik.
* Thu Mar 09 2006 - mt@suse.de
- Bug #148385, fixed "ipsec auto" parameter in html docs
  (different file, same bug).
* Wed Feb 08 2006 - mt@suse.de
- Bug #148385, fixed "ipsec auto" parameter in html docs.
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Sat Jan 14 2006 - kukuk@suse.de
- Add gmp-devel to nfb
* Mon Dec 19 2005 - ro@suse.de
- remove unpackaged symlinks
* Fri Nov 18 2005 - mt@suse.de
- Updated to openswan-2.4.4 fixing 3DES and aggressive mode
  related deny of service (VU#226364, 273756/NISCC/ISAKMP)
  as well as other issues. Bug #134158.
- Fixed link generation regex (openswan_08_doc-man2html.dif)
- Removed man2html source - not used any more to generate docs.
* Thu Oct 27 2005 - mt@suse.de
- Updated to openswan-2.4.0 (final). It does not provide any
  relevant changes in the source code (klips natt info only).
- Fixed Bug #116413 generation/installation of the html docs.
* Wed Sep 07 2005 - mt@suse.de
- Updated to openswan-2.4.0rc5 adding fix to dead peer
  detection cleanup and updown script. Adopted patches.
- Fixed return codes for "rcipsec status".
* Fri Aug 26 2005 - mt@suse.de
- Updated to openswan 2.4.0rc4 adding minor fixes
- Added workaround "plutowait=yes" setting to avoid failures of a
  first connect attempt in case where all crypto helpers was busy
  with setup of an other tunnel (Bug #412 on openswan.org).
  new patch file: openswan_42_plutowait-yes.dif
* Tue Aug 23 2005 - mt@suse.de
- Updated to openswan 2.4.0rc3 fixing a pluto crash when used
  with multiple L2TP/IPsec clients in transport mode behind NAT
* Fri Aug 19 2005 - mt@suse.de
- Updated to openswan 2.4.0rc1; obsoletetes patches:
  openswan_05_checkv199.dif, openswan_11_yyerror.dif,
  openswan_13_system.dif, openswan_20_noslave.dif,
  openswan_21_sigmask.dif, openswan_25_noxauth.dif,
  openswan_30_newhostkey.dif, openswan_36_ipsec_look.dif
- Applied diverse fixes for signed issues from cvs head:
  new patch file: openswan_11_gcc4cvshead.dif
* Tue Aug 16 2005 - mt@suse.de
- added dummy states if aggressive mode is disabled to
  avoid build dependend state numbering (from CVS head)
* Wed Aug 03 2005 - mt@suse.de
- improved aggressive mode patch openswan_24_noaggressive.dif
- merged updown patches 32 and 33 into openswan_32_updown-nexthop.dif,
  added skiping to add a route in some host to host tunnel cases
- renamed 36_sourceip-mask patch to openswan_33_updown-srcmask.dif
- renamed 12_gcc4sign patch to openswan_12_socklen.dif, improved
- renamed 13_gcc4warn patch to openswan_13_system.dif, improved
- added checks to ipsec look command to avoid "no such file" errors.
  new patch file: openswan_36_ipsec_look.dif
- workaround to load aes-$arch crypto module if not aliased (x86_64)
  new patch file: openswan_37_aes_insmod.dif
* Mon Jul 04 2005 - mt@suse.de
- Bug #66215: patch for updown script to solve SNAT/MASQUERADE
  problems with recent kernels, using netmask of the remote (peer)
  network instead of /32 for source address.
  New patch file: openswan_36_sourceip-mask.dif
* Mon Jul 04 2005 - mt@suse.de
- removed most of the GCC4 patch (openswan_12_gcc4sign.dif)
  because it breaks at least the asn1 decoding (pem parsing).
* Thu Jun 30 2005 - mt@suse.de
- added openswan_24_noaggressive.dif and openswan_25_noxauth.dif
  patches fixing dependencies to USE_AGGRESSIVE USE_XAUTH flags
- disabled AGGRESSIVE and XAUTH in openswan_00_features.dif
- added a openswan prefix to several source files
* Sat May 07 2005 - mt@suse.de
- added openswan_13_gcc4warn.dif patch, fixing diverse unused
  system() return codes mentioned by gcc4 in code using -Werror
* Sat May 07 2005 - mt@suse.de
- fixed GCC4 patch
* Sat May 07 2005 - mt@suse.de
- started to update to openswan-2.3.1
- adopted patches to match new sources
- renamed all patches to contain a number for
  manual applying and end with a .dif suffix
* Wed May 04 2005 - yxu@suse.de
- fixed for GCC4
* Mon Mar 21 2005 - mt@suse.de
- Bug #73863: added patch for _updown script to skip using nexthop
  (via parameter for ip route) if it is not reachable through any
  directly connected network (but via default route only).
  new patch file: openswan-updown-nexthop-not-local.dif
* Fri Jan 14 2005 - ro@suse.de
- use sigprocmask instead of sigsetmask in invokepluto
* Sun Sep 26 2004 - garloff@suse.de
- Fix initscript exit codes and messages. [#42604]
* Sat Sep 18 2004 - garloff@suse.de
- Update to openswan-2.2.0: Fixes for SA Selectors on 2.6.
- Add README.SUSE [#44368].
* Mon Sep 06 2004 - garloff@suse.de
- Update to openswan-2.2.0dr4: NAT-T & X.509 security fixes
- Drop openswan-dont-try-espinudp-on-ipv6.diff (integrated upstream)
- Drop openswan-natt.diff (integrated upstream)
* Sun Aug 29 2004 - garloff@suse.de
- Drop notification message.
* Thu Aug 19 2004 - garloff@suse.de
- Fix _realsetup script.
* Mon Aug 16 2004 - garloff@suse.de
- Fix noklips patch (but leave it disabled)
- NAT-T patch: The last message could have been wrongly be sent via
  the established tunnel.
* Fri Aug 13 2004 - garloff@suse.de
- Initial creation of openswan-2.2.0dr3
- Reuse many of the freeswan2 patches
